#include <gsl/gsl_sf_airy.h>
#include <stdio.h>
#include <stdlib.h>

int main(int ac, char *av[])
{
	double     x, x0, x1, h;
	gsl_mode_t m;

	if (ac < 3) { fprintf(stderr, "usage: %s x0 x1 step\n", av[0]); exit(1); }
	x0 = atof(av[1]);
	x1 = atof(av[2]);
	h  = atof(av[3]);
	x  = x0;
	m  = GSL_PREC_DOUBLE;
	while (x < x1) {
		printf("%lf\t%lf\t%lf\t%lf\t%lf\n", x, gsl_sf_airy_Ai(x,m),
		                                       gsl_sf_airy_Bi(x,m),
		                                       gsl_sf_airy_Ai_scaled(x,m),
		                                       gsl_sf_airy_Bi_scaled(x,m));
		x += h;
	}

	return 0;
}
