#include <stdio.h>
#include <gsl/gsl_randist.h>

int main()
{
	int k;
	puts("set pointsize 2");
	puts("set terminal epslatex");
	puts("set output \"neg_binomial.tex\"");
	puts("set title \"Negative Binomial Distribution\"");
	puts("set xlabel \"$k$\"");
	puts("set ylabel \"$p(k)$\"");
	puts("plot [-0.5:10.5][0:0.3] \"-\" title \"$p=0.5,~n=3.5$\" with points");
	for (k = 0; k <= 10; k++)
		printf("%d\t%f\n", k, gsl_ran_negative_binomial_pdf(k, 0.5, 3.5));

	return 0;
}
