#include <stdio.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>

void printhead();

int main (void)
{
    int i, k;
    double x, y, x0 = 0, y0 = 0, dx, dy;
    const gsl_rng_type * T;
    gsl_rng * r;
	unsigned long int seed[] = {1970ul, 1971ul, 1972ul};

    gsl_rng_env_setup();
    T = gsl_rng_default;
    r = gsl_rng_alloc(T);

	printhead();

	for (k = 0; k < 3; k++) {
		gsl_rng_set(r, seed[i]);
		x = x0; y= y0;
		printf("%g %g\n", x, y);
		for (i = 0; i < 10; i++) {
			gsl_ran_dir_2d(r, &dx, &dy);
			x += dx; y += dy;
			printf("%g %g\n", x, y);
		}
		puts("e");
	}

    gsl_rng_free(r);
    return 0;
}

void printhead()
{
	puts("set parametric");
	puts("set terminal epslatex size 10cm,10cm");
	puts("set output 'random_walk.tex'");
	puts("set title 'Random walk'");
	puts("unset key");
	puts("set xlabel 'x'");
	puts("set ylabel 'y'");
	puts("plot [-5:5][-5:5] '-' with linespoints,"
	                       "'-' with linespoints,"
	                       "'-' with linespoints");
}
