#include <stdio.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_histogram2d.h>

#define BINS 20

int main (int ac, char *av[])
{
    int i;
    const gsl_rng_type * T;
    gsl_rng * r;
    gsl_histogram2d * h = gsl_histogram2d_alloc(BINS, BINS);
    double **dat;
    FILE *INFILE;

    gsl_histogram2d_set_ranges_uniform(h, 0.0, 1.0, 0.0, 1.0);

    if (ac < 3) { puts("specify the number of data and the file."); exit(0); }
    INFILE = fopen(av[2], "r");
    dat = (double **)malloc(sizeof(double *) * atoi(av[1]));
    for (i = 0; i < atoi(av[1]); i++) {
        dat[i] = (double *)malloc(sizeof(double) * 2);
        fscanf(INFILE, "%lf%lf", &(dat[i][0]), &(dat[i][1]));
        gsl_histogram2d_accumulate(h, dat[i][0], dat[i][1], 1);
    }

    gsl_histogram2d_fprintf(stdout, h, "%f", "%f");
    gsl_histogram2d_free(h);

    return 0;
}

